// Define the maximum number of arrays in S
const int numFrames = 9; 
const int N = 25; // number of mirrors
const int mPins[N] = {4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28};
const int minDelay = 40;
const int maxDelay = 150;

int delayTime = 80; // delay time per update
int aRead;

struct V_s {
  int* F;
  int Length; // Length of the array
};

V_s V[numFrames]; // create structure that contains all the frames in the sequence

int* previousFrame = nullptr; // initialize an array for the previous frame that can change size
int previousFrameLength = 0;

int* currentFrame = nullptr; // initialize an array for the current frame that can change size
int currentFrameLength = 0;

bool found;

void setup() {

  for (int p = 0; p < N; p++) {
    pinMode(mPins[p], OUTPUT);
  }

  pinMode(A0, INPUT); // input for pot
  

  // Store frames in structure V. Each array F contains the mirror that must be set high in that frame.
    V[0].Length = 1;
    V[0].F = new int[V[0].Length] {0};
    V[1].Length = 2;
    V[1].F = new int[V[1].Length] {1, 5};
    V[2].Length = 3;
    V[2].F = new int[V[2].Length] {2, 6, 10};
    V[3].Length = 4;
    V[3].F = new int[V[3].Length] {3, 7, 11, 15};
    V[4].Length = 5;
    V[4].F = new int[V[4].Length] {4, 8, 12, 16, 20};
    V[5].Length = 4;
    V[5].F = new int[V[5].Length] {9, 13, 17, 21};
    V[6].Length = 3;
    V[6].F = new int[V[6].Length] {14, 18, 22};
    V[7].Length = 2;
    V[7].F = new int[V[7].Length] {19, 23};
    V[8].Length = 1;
    V[8].F = new int[V[8].Length] {24};

//  V[0].Length = 1;
//  V[0].F = new int[V[0].Length] {0};
//  V[1].Length = 1;
//  V[1].F = new int[V[1].Length] {1};
//  V[2].Length = 1;
//  V[2].F = new int[V[2].Length] {2};
//  V[3].Length = 1;
//  V[3].F = new int[V[3].Length] {3};
//  V[4].Length = 1;
//  V[4].F = new int[V[4].Length] {4};
//  V[5].Length = 1;
//  V[5].F = new int[V[5].Length] {9};
//  V[6].Length = 1;
//  V[6].F = new int[V[6].Length] {14};
//  V[7].Length = 1;
//  V[7].F = new int[V[7].Length] {19};
//  V[8].Length = 1;
//  V[8].F = new int[V[8].Length] {24};
//  V[9].Length = 1;
//  V[9].F = new int[V[9].Length] {23};
//  V[10].Length = 1;
//  V[10].F = new int[V[10].Length] {22};
//  V[11].Length = 1;
//  V[11].F = new int[V[11].Length] {21};
//  V[12].Length = 1;
//  V[12].F = new int[V[12].Length] {20};
//  V[13].Length = 1;
//  V[13].F = new int[V[13].Length] {15};
//  V[14].Length = 1;
//  V[14].F = new int[V[14].Length] {10};
//  V[15].Length = 1;
//  V[15].F = new int[V[15].Length] {5};
//  V[16].Length = 1;
//  V[16].F = new int[V[16].Length] {6};
//  V[17].Length = 1;
//  V[17].F = new int[V[17].Length] {7};
//  V[18].Length = 1;
//  V[18].F = new int[V[18].Length] {8};
//  V[19].Length = 1;
//  V[19].F = new int[V[19].Length] {13};
//  V[20].Length = 1;
//  V[20].F = new int[V[20].Length] {18};
//  V[21].Length = 1;
//  V[21].F = new int[V[21].Length] {17};
//  V[22].Length = 1;
//  V[22].F = new int[V[22].Length] {16};
//  V[23].Length = 1;
//  V[23].F = new int[V[23].Length] {11};
//  V[24].Length = 1;
//  V[24].F = new int[V[24].Length] {12};
//  V[25].Length = 1;
//  V[25].F = new int[V[25].Length] {11};
//  V[26].Length = 1;
//  V[26].F = new int[V[26].Length] {16};
//  V[27].Length = 1;
//  V[27].F = new int[V[27].Length] {17};
//  V[28].Length = 1;
//  V[28].F = new int[V[28].Length] {18};
//  V[29].Length = 1;
//  V[29].F = new int[V[29].Length] {13};
//  V[30].Length = 1;
//  V[30].F = new int[V[30].Length] {8};
//  V[31].Length = 1;
//  V[31].F = new int[V[31].Length] {7};
//  V[32].Length = 1;
//  V[32].F = new int[V[32].Length] {6};
//  V[33].Length = 1;
//  V[33].F = new int[V[33].Length] {5};
//  V[34].Length = 1;
//  V[34].F = new int[V[34].Length] {10};
//  V[35].Length = 1;
//  V[35].F = new int[V[35].Length] {15};
//  V[36].Length = 1;
//  V[36].F = new int[V[36].Length] {20};
//  V[37].Length = 1;
//  V[37].F = new int[V[37].Length] {21};
//  V[38].Length = 1;
//  V[38].F = new int[V[38].Length] {22};
//  V[39].Length = 1;
//  V[39].F = new int[V[39].Length] {23};
//  V[40].Length = 1;
//  V[40].F = new int[V[40].Length] {24};
//  V[41].Length = 1;
//  V[41].F = new int[V[41].Length] {19};
//  V[42].Length = 1;
//  V[42].F = new int[V[42].Length] {14};
//  V[43].Length = 1;
//  V[43].F = new int[V[43].Length] {9};
//  V[44].Length = 1;
//  V[44].F = new int[V[44].Length] {4};
//  V[45].Length = 1;
//  V[45].F = new int[V[45].Length] {3};
//  V[46].Length = 1;
//  V[46].F = new int[V[46].Length] {2};
//  V[47].Length = 1;
//  V[47].F = new int[V[47].Length] {1};


  for (int j = 0; j < V[numFrames-1].Length; j++) {

    digitalWrite(mPins[V[numFrames-1].F[j]], HIGH);

  }
  delay(delayTime);

  previousFrame = V[numFrames-1].F;
  previousFrameLength = V[numFrames-1].Length;

}

void loop() {


  for (int i = 0; i < numFrames; i++) {

    currentFrame = V[i].F;
    currentFrameLength = V[i].Length;
    aRead = analogRead(A0);
    delayTime = map(aRead, 0, 255, minDelay,maxDelay); // map(value, fromLow, fromHigh, toLow, toHigh)


    // check which mirrors from previous frame that need to be switched to LOW
    for (int i = 0; i < previousFrameLength; i++) { // select mirror i from previous frame
      found = false;
      for (int j = 0; j < currentFrameLength; j++) { // cycle through mirrors in current frame that must be set to HIGH
        if (previousFrame[i] == currentFrame[j]) { // mirror j in the new frame is already HIGH from previous frame
          found = true;
          break;
        }

        if (!found) { // mirror i in previous frame is not high in the next frame
          digitalWrite(mPins[previousFrame[i]], LOW); // set this mirror back to low
        }
      }
    }

    // check which mirrors from current frame that were not on in previous frame, these need to be set to HIGH
    for (int i = 0; i < currentFrameLength; i++) { // select mirror i from current frame
      found = false;
      for (int j = 0; j < previousFrameLength; j++) { // cycle through previous mirrors
        if (currentFrame[i] == previousFrame[j]) { // mirror i in the new frame is already HIGH from previous frame
          found = true;
          break;
        }

        if (!found) { // mirror i in current frame wasn't set to high in previous frame
          digitalWrite(mPins[currentFrame[i]], HIGH); // set mirror i from current frame to HIGH
        }
      }
    }



    delay(delayTime);

    

    previousFrameLength = currentFrameLength;
    previousFrame = currentFrame;

  }


}
